#
# This is the SPEC file for creating binary RPMs for the Dom0.
#
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
# Copyright (C) 2010  Rafal Wojtczuk  <rafal@invisiblethingslab.com>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, see <https://www.gnu.org/licenses/>.
#
#

Name:		qubes-core-qrexec
Version:	4.1.19
Release:	1%{dist}
Summary:	The Qubes qrexec files (common files)

Group:		Qubes
Vendor:		Invisible Things Lab
License:	GPL
URL:		http://www.qubes-os.org

BuildRequires:	gcc
BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:	python%{python3_pkgversion}-dbus
# for building documentation
BuildRequires:	python%{python3_pkgversion}-sphinx
BuildRequires:	python%{python3_pkgversion}-recommonmark
BuildRequires:	qubes-libvchan-devel
BuildRequires:  python%{python3_pkgversion}-rpm-macros

Requires:   python%{python3_pkgversion}
Requires:   python%{python3_pkgversion}-gbulb
Conflicts:  qubes-utils-libs < 4.1.0
Conflicts:  qubes-core-agent-qrexec < 4.1.0
Conflicts:  qubes-core-dom0 < 4.1.10
Conflicts:  qubes-core-dom0-linux < 4.1.5
Conflicts:  qubes-gui-agent < 4.1.6
Conflicts:  qubes-gpg-split < 2.0.45
Conflicts:  qubes-gui-daemon < 4.1.4
Conflicts:  qubes-input-proxy < 1.0.17
Conflicts:  qubes-pdf-converter < 2.1.7
Conflicts:  qubes-usb-proxy < 1.0.28

Source0: qubes-core-qrexec-%{version}.tar.gz

%description
The Qubes qrexec files for installation on both dom0 and qube.

%package libs
Summary:    Libraries for qubes-qrexec
Conflicts:  qubes-utils-libs < 4.1.0

%description libs
Libraries for qubes-qrexec

%package devel
Summary:    Development headers for qubes-qrexec
Requires:   %{name}-libs

%description devel
Development header and files for qubes-qrexec

%prep
%setup -qn qubes-core-qrexec-%{version}

%build
%{?set_build_flags}
make all-base PYTHON=%{__python3}
make -C doc PYTHON=python3 SPHINXBUILD=sphinx-build-3 man

%install
make install-base \
    INCLUDEDIR=%{_includedir} \
    LIBDIR=%{_libdir} \
    SYSCONFDIR=%{_sysconfdir} \
    UNITDIR=%{_unitdir} \
    PYTHON_SITEPATH=%{python3_sitelib} \
    PYTHON=%{__python3} \
    DESTDIR=$RPM_BUILD_ROOT

make -C doc \
    DESTDIR=$RPM_BUILD_ROOT \
    SPHINXBUILD=sphinx-build-3 \
    install

%clean
rm -rf $RPM_BUILD_ROOT
rm -f %{name}-%{version}

%files
%defattr(-,root,root,-)

%{_bindir}/qrexec-policy-exec
%{_bindir}/qrexec-policy-agent
%{_bindir}/qrexec-policy-graph
%{_bindir}/qrexec-policy-restore
%{_bindir}/qrexec-policy-daemon
%{_bindir}/qubes-policy
%{_bindir}/qubes-policy-admin
%{_bindir}/qrexec-policy

/usr/lib/qubes/qubes-rpc-multiplexer
/usr/lib/qubes/qrexec-policy-agent-autostart

%{_sysconfdir}/qubes-rpc/policy.Ask
%{_sysconfdir}/qubes-rpc/policy.Notify

%{_sysconfdir}/xdg/autostart/qrexec-policy-agent.desktop

%dir %{python3_sitelib}/qrexec-*.egg-info
%{python3_sitelib}/qrexec-*.egg-info/*

%dir %{python3_sitelib}/qrexec
%dir %{python3_sitelib}/qrexec/__pycache__
%{python3_sitelib}/qrexec/__pycache__/*
%{python3_sitelib}/qrexec/__init__.py
%{python3_sitelib}/qrexec/client.py
%{python3_sitelib}/qrexec/exc.py
%{python3_sitelib}/qrexec/utils.py
%{python3_sitelib}/qrexec/server.py

%dir %{python3_sitelib}/qrexec/policy
%dir %{python3_sitelib}/qrexec/policy/__pycache__
%{python3_sitelib}/qrexec/policy/__pycache__/*
%{python3_sitelib}/qrexec/policy/__init__.py
%{python3_sitelib}/qrexec/policy/admin.py
%{python3_sitelib}/qrexec/policy/admin_client.py
%{python3_sitelib}/qrexec/policy/parser.py
%{python3_sitelib}/qrexec/policy/parser_compat.py
%{python3_sitelib}/qrexec/policy/utils.py

%dir %{python3_sitelib}/qrexec/tools
%dir %{python3_sitelib}/qrexec/tools/__pycache__
%{python3_sitelib}/qrexec/tools/__pycache__/*
%{python3_sitelib}/qrexec/tools/__init__.py
%{python3_sitelib}/qrexec/tools/qubes_policy.py
%{python3_sitelib}/qrexec/tools/qubes_policy_admin.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_agent.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_exec.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_daemon.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_graph.py
%{python3_sitelib}/qrexec/tools/qrexec_policy_restore.py

%dir %{python3_sitelib}/qrexec/tests
%dir %{python3_sitelib}/qrexec/tests/__pycache__
%{python3_sitelib}/qrexec/tests/__pycache__/*
%{python3_sitelib}/qrexec/tests/__init__.py
%{python3_sitelib}/qrexec/tests/cli.py
%{python3_sitelib}/qrexec/tests/gtkhelpers.py
%{python3_sitelib}/qrexec/tests/rpcconfirmation.py
%{python3_sitelib}/qrexec/tests/policy_parser.py
%{python3_sitelib}/qrexec/tests/qrexec_policy_daemon.py
%{python3_sitelib}/qrexec/tests/policy_cache.py
%{python3_sitelib}/qrexec/tests/server.py
%{python3_sitelib}/qrexec/tests/policy_admin.py

%dir %{python3_sitelib}/qrexec/tests/socket
%dir %{python3_sitelib}/qrexec/tests/socket/__pycache__
%{python3_sitelib}/qrexec/tests/socket/__pycache__/*
%{python3_sitelib}/qrexec/tests/socket/__init__.py
%{python3_sitelib}/qrexec/tests/socket/agent.py
%{python3_sitelib}/qrexec/tests/socket/daemon.py
%{python3_sitelib}/qrexec/tests/socket/qrexec.py
%{python3_sitelib}/qrexec/tests/socket/util.py

%dir %{python3_sitelib}/qrexec/glade
%{python3_sitelib}/qrexec/glade/RPCConfirmationWindow.glade

%{_datadir}/man/man1/qubes-core-qrexec.1.gz

%files devel
%{_includedir}/qrexec.h
%{_includedir}/libqrexec-utils.h

%files libs
%{_libdir}/libqrexec-utils.so*

%changelog
* Wed Nov 23 2022 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-core-qrexec.git

* Wed Nov 23 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7dc10e6
- version 4.1.19

* Wed Nov 23 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 24ee2bb
- Update fuzzer wrapper

* Wed Nov 23 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d6cf068
- Ignore oversensitive pylint warnings

* Wed Nov 23 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e47575e
- ci: install extra packages necessary for unit tests

* Wed Nov 23 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 3d02188
- Prevent log injection into qrexec-agent

* Sat Mar 05 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 75e794e
- version 4.1.18

* Wed Mar 02 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 92a1734
- Fix parsing legacy policy files

* Fri Feb 18 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7f910aa
- version 4.1.17

* Tue Feb 15 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6c78dc3
- policy: fix notification on refused autostart

* Fri Jan 14 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c8e83f9
- Fix error return value in allocate_vchan_port

* Fri Dec 17 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ebdc43b
- version 4.1.16

* Thu Dec 16 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5014923
- policy: fix reporting failed target start

* Tue Dec 14 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - a668ac1
- Check the return value of snprintf

* Sun Aug 22 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 339f79a
- Add assertions that FD_SETSIZE is not exceeded

* Thu Jul 01 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 12e0092
- version 4.1.15

* Wed Jun 30 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 0516ffc
- Fix FD leak causing DispVMs not being cleaned up properly

* Fri Jun 18 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - bf76f79
- version 4.1.14

* Thu Jun 17 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f7d510b
- Force color pytest output in gitlab

* Tue Jun 01 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 4fc2578
- Add a test for qrexec policy allowing an operation

* Tue Jun 01 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 46f57e8
- Parse the qrexec call metadata before untrusted data

* Tue Jun 01 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 3ba64f3
- Avoid calling get_system_info() twice

* Tue Jun 01 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 4276035
- Automatically install dependencies when possible

* Tue Jun 01 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 831208f
- Handle partial reads from StreamReader.read

* Tue Jun 01 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 0b2332f
- Set socket modes properly

* Tue Jun 01 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 61d603c
- Shut up pylint

* Tue Jun 01 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - dcff4f7
- Lots of unit tests and some bug fixes

* Sat May 22 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 121aff1
- Use separate sockets for different services

* Sat May 22 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - c1d8dd9
- Do not use the asynctest module

* Sat May 22 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 93190cf
- Add policy.EvalGUI service

* Fri May 21 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 587dac3
- Create a DispVMTemplate instance when needed

* Fri May 21 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 2f0d37a
- Use generic 'guivm' service to tell if running inside GUI VM

* Fri May 21 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 0d79f74
- Tell pylint not to whine about extra parentheses

* Fri May 21 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - adb1301
- Add unit tests for policy.EvalSimple

* Fri May 21 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - e08a112
- Add a policy.EvalSimple qrexec service

* Thu May 20 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - cbab1fc
- Switch from __gcov_flush to __gcov_dump + __gcov_reset

* Mon May 17 2021 Demi Marie Obenour <demi@invisiblethingslab.com> - 46dc9c1
- Be stricter about command-line parsing

* Thu Mar 04 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c636c53
- daemon: fix checking qrexec-policy-daemon response

* Thu Mar 04 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - afea444
- Adjust vchan_{send,recv} error checking

* Wed Jan 27 2021 Dmitry Fedorov <d.fedorov@tabit.pro> - fdd306f
- winusb: check if pam include file exists and set appropriate flags

* Wed Jan 27 2021 Dmitry Fedorov <d.fedorov@tabit.pro> - 2ce1a34
- winsub: fix broad exception

* Thu Jan 21 2021 Dmitry Fedorov <d.fedorov@tabit.pro> - 4c5ba18
- winusb: append LDLIBS

* Tue Jan 19 2021 Dmitry Fedorov <d.fedorov@tabit.pro> - dbb6b51
- winusb: set guivm to None on unknown source

* Tue Jan 19 2021 Dmitry Fedorov <d.fedorov@tabit.pro> - ef92037
- winusb: allow to build without pam

* Sun Jan 10 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7d75d31
- version 4.1.13

* Fri Jan 08 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 41e36f7
- agent: do not interrupt established connections on restart

* Tue Jan 05 2021 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ed34dc7
- version 4.1.12

* Sat Dec 12 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 7e4e562
- debian: update compat

* Sat Dec 12 2020 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 7f35ef8
- debian: update control

* Wed Nov 25 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 463ce10
- pylint: temporarily disable unsubscriptable-object - buggy with py3.9

* Wed Nov 25 2020 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 863242c
- gitlab-ci: include custom jobs

